#include<bits/stdc++.h>
using namespace std;
int main(){
	int n,k;
	cin>>n>>k;
	int a[n];
	for(int i=0;i<n;i++)cin>>a[i];
	int an[n+1],ap[n+1];
	for(int i=0;i<n+1;i++){
		an[i]=0;
		ap[i]=0;
	}
	for(int i=0;i<n;i++){
		if(a[i]>=0)ap[a[i]]+=1;
		else an[abs(a[i])]+=1;
	}
	int br=0;
	for(int i=0;i<n+1;i++){
		if(ap[i]>=k)br++;
		if(an[i]>=k)br++;
	}
	cout<<br<<endl;
	for(int i=n;i>0;i--)if(an[i]>=k)cout<<-i<<" ";
	for(int i=0;i<n+1;i++)if(ap[i]>=k)cout<<i<<" ";
}